(ns com.aurellem.run.sound
  (:use (com.aurellem.gb saves gb-driver util constants
                         items vbm characters money
                         rlm-assembly))
  (:use (com.aurellem.run util music title save-corruption
                          bootstrap-0 bootstrap-1))
  (:require clojure.string)
  (:import [com.aurellem.gb.gb_driver SaveState])
  (:import java.awt.image.BufferedImage)
  (:import java.io.File))


(defn sound-test []
  (step (mid-game))
  (println (frequencies (sound-data)))
  (run-moves @current-state (repeat 10 []))
  (println (frequencies (sound-data))))


(import javax.sound.sampled.AudioFormat)
(import com.aurellem.gb.WaveWriter)

(def probable-format (AudioFormat. 44100 16 2 true false))

(defn test-writing-file! [n]
  (set-state! (play-midi pony-csv))
  (let [target-file
        (File. "/home/r/proj/vba-clojure/test-sound.wav")
        writer (WaveWriter. target-file)]
    (dorun
     (for [y (range n)]
       (do
         (let [quanta 30]
           (run-moves @current-state (repeat quanta []))
           (let [data (sound-data)
                 step-section
                 (byte-array (take (* 2940 quanta) data))]
             
             (.process writer step-section probable-format))))))
     (.cleanup writer)
     (Thread/sleep 1000)
     (clojure.java.shell/sh
      "aplay"
      (.getCanonicalPath target-file))))
      